# coding: UTF-8
import urllib.request
import unittest

# import pyautogui as ag
import requests
import fitz
import pypdf
from lxml import etree
# import PyPDF225

from receipt import Receipts

class Test(unittest.TestCase):
    receipt = Receipts()

    def test_xml(self):
        xml = etree.parse('/home/deeejas/git/pyanaf/sample_files/D300_21480386_2021_02.xml')
        root = xml.getroot()
        print(root)
        tree = xml.xpath('/xmlns:declaratie300/*', namespaces={'xmlns': 'mfp:anaf:dgti:d300:declaratie:v6'})
        print(tree)

    def test_pdfread(self):
        self.receipt.pdf_reader('sample_files/202550755_17259191_D394_1_2020.pdf')
        print(self.receipt.mesaj.strip())

    def test_pypdf_read(self):
        pdf = pypdf.PdfReader('sample_files/202550755_17259191_D394_1_2020.pdf')
        pdf_page = pdf.getPage(0)
        text = pdf_page.extractText()
        print(text)

    def test_pypdf2_read(self):
        pdf = pypdf.PdfReader('sample_files/202550755_17259191_D394_1_2020.pdf')
        pdf_page = pdf.pages[0]
        text = pdf_page.extract_text()
        print(text)

    def test_pymupdf_read(self):
        pdf = fitz.Document('sample_files/202550755_17259191_D394_1_2020.pdf')
        pdf_page = pdf.load_page(0)
        text = pdf_page.get_text('text')
        print(text)

    def test_dir(self):
        receipt = Receipts()
        print(receipt._dir_fdate())


if __name__ == '__main__':
    unittest.main()
